#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Carrot
execute as @a[scores={Idea2UseCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:51}}}] at @s run function 8_ideas2:pig/equip
execute as @a[scores={Idea2UseCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:53}}},tag=!idea_stick_select] at @s run function 8_ideas2:stick/click
scoreboard players set @a[scores={Idea2UseCarrot=1..}] Idea2UseCarrot 0

# Walking
execute at @a[predicate=8_ideas2:pig/walk] run playsound minecraft:entity.pig.ambient master @a ~ ~ ~ 1 1.2
scoreboard players set @a[scores={Idea2Walk=1..}] Idea2Walk 0

# Death
execute as @a[tag=pig_morph,scores={Idea2Death=1..}] at @s run function 8_ideas2:pig/unmorph
scoreboard players set @a[scores={Idea2Death=1..}] Idea2Death 0

# Launch
scoreboard players remove @a[scores={Idea2Launch=1..}] Idea2Launch 1
effect give @a[scores={Idea2Launch=2..}] levitation 10 110 true
effect clear @a[scores={Idea2Launch=1}] levitation

# ===================================================================================

# Fish Gun

execute as @e[type=minecraft:firework_rocket] if data entity @s FireworksItem.tag.Fish run kill @s

execute as @a[nbt={SelectedItem:{tag:{Fish:1b}}}] unless data entity @s SelectedItem.tag.ChargedProjectiles[] run replaceitem entity @s weapon.mainhand crossbow{ChargedProjectiles:[{id:"firework_rocket",Count:1b,tag:{Fish:1b,CustomModelData:51}}],Charged:1b,display:{Name:'{"text":"Fish Blaster","italic":"false","color":"aqua"}'},Fish:1b,CustomModelData:51}

execute as @a[nbt={Inventory:[{Slot:-106b,tag:{Fish:1b}}]}] unless data entity @s Inventory[{Slot:-106b}].tag.ChargedProjectiles[] run replaceitem entity @s weapon.offhand crossbow{ChargedProjectiles:[{id:"firework_rocket",Count:1b,tag:{Fish:1b,CustomModelData:51}}],Charged:1b,display:{Name:'{"text":"Fish Blaster","italic":"false","color":"aqua"}'},Fish:1b,CustomModelData:51}
    
execute as @a[scores={Idea2FishUse=1..},nbt={SelectedItem:{tag:{Fish:1b}}}] at @s anchored eyes run function 8_ideas2:fish/shoot

execute as @a[scores={Idea2FishTime=1..}] at @s anchored eyes run function 8_ideas2:fish/fish
scoreboard players remove @a[scores={Idea2FishTime=1..}] Idea2FishTime 1

scoreboard players add @e[tag=fish] Idea2FishTime 1
execute as @e[tag=fish,scores={Idea2FishTime=60..}] if predicate 8_ideas2:fish/despawn at @s run tp @s ~ -500 ~
execute at @e[tag=fish,scores={Idea2FishTime=..10}] run fill ~5 ~5 ~5 ~-5 ~-5 ~-5 water[level=15] replace fire

scoreboard players add @e[tag=fish_fireball] Idea2FishTime 1
kill @e[tag=fish_fireball,scores={Idea2FishTime=10..}]

# =======================================================================================

# Pig Hat

execute as @a[tag=pig_morph] at @e[tag=idea_pig] if score @s Idea2PigID = @e[tag=idea_pig,distance=..0.1,limit=1] Idea2PigID run tp @e[tag=idea_pig,distance=..0.1,limit=1] @s
execute as @a[tag=pig_morph] at @e[tag=idea_pig] if score @s Idea2PigID = @e[tag=idea_pig,distance=..0.1,limit=1] Idea2PigID run tag @s add pig

execute as @a[tag=pig_morph,tag=!pig] at @s run function 8_ideas2:pig/unmorph
tag @a[tag=pig] remove pig

# ========================================================================================

# Cake of Illusion

execute at @e[tag=new_idea_cake] run setblock ~ ~ ~ cake
scoreboard players set @e[tag=new_idea_cake] Idea2Cake 0
execute at @e[tag=new_idea_cake] run playsound minecraft:block.wool.place block @a ~ ~ ~ 1 0.8
tag @e[tag=new_idea_cake] remove new_idea_cake

execute as @e[tag=idea_cake,scores={Idea2Cake=..6}] at @s unless block ~ ~ ~ cake run kill @s
execute at @e[tag=idea_cake] run particle composter ~ ~ ~ 0.4 0.4 0.4 1 1

execute as @e[tag=idea_cake,scores={Idea2Cake=0}] at @s unless block ~ ~ ~ cake[bites=0] run function 8_ideas2:cake/1
execute as @e[tag=idea_cake,scores={Idea2Cake=1}] at @s unless block ~ ~ ~ cake[bites=1] run function 8_ideas2:cake/2    
execute as @e[tag=idea_cake,scores={Idea2Cake=2}] at @s unless block ~ ~ ~ cake[bites=2] run function 8_ideas2:cake/3
execute as @e[tag=idea_cake,scores={Idea2Cake=3}] at @s unless block ~ ~ ~ cake[bites=2] run function 8_ideas2:cake/4
execute as @e[tag=idea_cake,scores={Idea2Cake=4}] at @s unless block ~ ~ ~ cake[bites=3] run function 8_ideas2:cake/5
execute as @e[tag=idea_cake,scores={Idea2Cake=5}] at @s unless block ~ ~ ~ cake[bites=4] run function 8_ideas2:cake/6
execute as @e[tag=idea_cake,scores={Idea2Cake=6}] at @s unless block ~ ~ ~ cake[bites=5] run function 8_ideas2:cake/7
execute as @e[tag=idea_cake,scores={Idea2Cake=7}] at @s unless block ~ ~ ~ cake[bites=6] run function 8_ideas2:cake/8
    
execute at @e[tag=idea_cake,scores={Idea2Cake=8..}] run function 8_ideas2:cake/rain
scoreboard players add @e[tag=idea_cake,scores={Idea2Cake=8..}] Idea2Cake 1

kill @e[tag=idea_cake,scores={Idea2Cake=400..}]

execute at @e[tag=cake_rain] run effect give @a[distance=..3] minecraft:instant_damage 1 0 true

# =============================================================================================

# Cloud

execute as @e[tag=idea_cloud_llama] at @s positioned ~ ~0.83 ~ if entity @a[distance=..0.31] run data modify entity @s Rotation set from entity @p[distance=..0.31] Rotation
    
execute as @e[tag=idea_cloud_llama] unless data entity @s Leash at @s positioned ~ ~0.83 ~ if entity @a[distance=..0.31] at @s if block ^ ^ ^0.5 air run tp @s ^ ^ ^0.5
        
# execute at @e[tag=idea_cloud] if predicate 8_ideas2:cloud/sound run function 8_ideas2:cloud/sound

execute at @e[tag=idea_cloud_llama] as @e[tag=idea_cloud] if score @s Idea2CloudID = @e[tag=idea_cloud_llama,distance=..0.1,limit=1] Idea2CloudID run tp @s ~ ~ ~ 0 0
    
execute as @e[tag=idea_cloud_llama] at @s positioned ~ ~0.83 ~ unless entity @a[distance=..0.31] at @s run tp @s ~-0.01 ~ ~
    
execute as @e[tag=idea_cloud_llama] at @s positioned ~ -20 ~ if entity @s[distance=..1] as @e[tag=idea_cloud] if score @s Idea2CloudID = @e[tag=idea_cloud_llama,distance=..0.1,limit=1] Idea2CloudID run kill @s
execute as @e[tag=idea_cloud_llama] at @s positioned ~ -20 ~ if entity @s[distance=..1] run kill @s
execute as @e[tag=idea_cloud_llama] at @s unless entity @a[distance=..20] run tp @s ~ -20 ~
    
execute as @e[type=minecraft:fishing_bobber,predicate=8_ideas2:cloud/sky] at @s run function 8_ideas2:cloud/rod

execute as @e[tag=idea_cloud_llama] if data entity @s DecorItem run data modify entity @s DecorItem set value {}
              
# ==============================================================================================

# Sticky Stick

effect clear @e[tag=idea_stick_selected] glowing
effect give @e[tag=idea_stick_select] glowing 1 1 true
tag @e[tag=idea_stick_selected] remove idea_stick_selected

scoreboard players set @a Idea2Raycast 100
execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:53}}}] unless score @s Idea2StickID matches 1.. at @s anchored eyes run function 8_ideas2:stick/raycast
tag @a[tag=idea_stick_raycast] remove idea_stick_raycast

effect give @e[tag=idea_stick_selected] glowing 1 1 true

team join Idea2Stick @e[tag=idea_stick_select,team=!Idea2Stick]
team leave @e[tag=!idea_stick_select,team=Idea2Stick]

execute as @a[scores={Idea2StickID=1..},tag=!idea_stick_select] at @s run function 8_ideas2:stick/tp
scoreboard players set @a[scores={Idea2StickID=1..},tag=!idea_stick_select] Idea2Raycast 40
execute as @a[scores={Idea2StickID=1..},tag=!idea_stick_select] at @s anchored eyes run function 8_ideas2:stick/particle

effect give @a[tag=idea_stick_select] minecraft:levitation 1 255 true

# ================================================================================================

# Spring Trap
execute as @e[tag=new_idea_trap] at @s align xyz run tp @s ~0.5 ~ ~0.5
execute as @e[tag=new_idea_trap] at @s run function 8_ideas2:trap/place
execute as @e[tag=idea_trap] at @s if block ~ ~-1 ~ air run function 8_ideas2:trap/break
execute as @e[tag=idea_trap] at @s unless block ~ ~ ~ barrier run function 8_ideas2:trap/break
    
scoreboard players remove @e[tag=idea_trap,scores={Idea2Trap=1..}] Idea2Trap 1
execute as @e[tag=idea_trap,scores={Idea2Trap=1}] at @s run function 8_ideas2:trap/off

execute if entity @e[tag=idea_trap] as @a at @s align xyz positioned ~0.5 ~-2 ~0.5 unless block ~ ~1 ~ air if entity @e[tag=idea_trap,tag=!idea_trap_on,distance=..0.1] run function 8_ideas2:trap/launch
            
# ================================================================================================

# Tomato
execute as @e[type=snowball,scores={Idea2Tomato=4..}] at @s if entity @a[distance=..3] run function 8_ideas2:tomato/hit
scoreboard players add @e[type=snowball] Idea2Tomato 1

execute as @e[type=snowball,nbt={Item:{tag:{CustomModelData:51}}}] at @s unless block ~ ~-1 ~ air run function 8_ideas2:tomato/bounce
    
execute as @e[tag=new_idea_tomato_plant] at @s align xyz run tp @s ~0.5 ~ ~0.5
execute as @e[tag=new_idea_tomato_plant] at @s if block ~ ~-1 ~ #8_ideas2:plant run function 8_ideas2:tomato/place
execute as @e[tag=idea_tomato_plant] at @s unless block ~ ~-1 ~ #8_ideas2:plant run function 8_ideas2:tomato/break
    
execute as @e[tag=idea_tomato_plant] at @s unless block ~ ~ ~ minecraft:sweet_berry_bush run function 8_ideas2:tomato/break
    
execute as @e[tag=idea_tomato_plant,tag=!idea_tomato_grow] at @s unless block ~ ~ ~ sweet_berry_bush[age=0] run function 8_ideas2:tomato/grow

execute as @e[tag=idea_tomato_plant,tag=idea_tomato_grow] at @s if block ~ ~ ~ sweet_berry_bush[age=1] run function 8_ideas2:tomato/shrink
tag @e[type=item,tag=!idea_tagged,nbt={Item:{id:"minecraft:sweet_berries"}}] add idea_tagged
execute at @e[tag=idea_tomato_plant,tag=idea_tomato_grow] run setblock ~ ~ ~ sweet_berry_bush[age=2]

# ===============================================================================================

# Villager TNT
execute as @e[tag=new_idea_tnt] at @s align xyz run tp @s ~0.5 ~ ~0.5
execute as @e[tag=new_idea_tnt] at @s run function 8_ideas2:tnt/place
execute as @e[tag=idea_tnt] at @s unless block ~ ~ ~ note_block run function 8_ideas2:tnt/break
execute as @e[tag=idea_tnt] at @s if block ~ ~ ~ note_block[powered=true] run function 8_ideas2:tnt/explode
    
execute as @e[tag=idea_tnt_villager] at @s run tp @s ~ ~ ~ facing entity @p
execute at @e[tag=idea_tnt] run particle minecraft:happy_villager ~ ~ ~ 0.5 0.5 0.5 100 1

scoreboard players add @e[tag=idea_tnt_spread1] Idea2Tnt 1
execute as @e[tag=idea_tnt_spread1,nbt={Invulnerable:1b},scores={Idea2Tnt=40..}] run data modify entity @s Invulnerable set value 0b

# =============================================================================================

# Scroll
execute as @a[tag=idea_judge] if data entity @s RootVehicle at @s run function 8_ideas2:game/scroll/check

execute as @e[tag=idea_judge] unless score @s Idea2Score1 matches 0.. run scoreboard players set @s Idea2Score1 10
execute as @e[tag=idea_judge] unless score @s Idea2Score2 matches 0.. run scoreboard players set @s Idea2Score2 10
    
title @a[tag=idea_judge,tag=idea_judge_green] title ""
title @a[tag=idea_judge,tag=idea_judge_green] times 0 20 0
execute as @a[tag=idea_judge,tag=idea_judge_green] run title @s subtitle {"score":{"name":"@s","objective":"Idea2Score1"},"color":"green"}

title @a[tag=idea_judge,tag=idea_judge_blue] title ""
title @a[tag=idea_judge,tag=idea_judge_blue] times 0 20 0
execute as @a[tag=idea_judge,tag=idea_judge_blue] run title @s subtitle {"score":{"name":"@s","objective":"Idea2Score2"},"color":"#0090ff"}

execute as @e[tag=green_button] at @s if block ~ ~ ~ stone_button[powered=true] run function 8_ideas2:game/button/green
execute as @e[tag=blue_button] at @s if block ~ ~ ~ stone_button[powered=true] run function 8_ideas2:game/button/blue
execute as @e[tag=update_button] at @s if block ~ ~ ~ birch_button[powered=true] run function 8_ideas2:game/button/update
    
execute at @e[tag=green_button] run setblock ~ ~ ~ stone_button[face=floor]
execute at @e[tag=blue_button] run setblock ~ ~ ~ stone_button[face=floor]
execute at @e[tag=update_button] run setblock ~ ~ ~ birch_button[face=floor]

execute at @e[tag=green_button] run particle dust 0 1 0 0.5 ~ ~0.2 ~
execute at @e[tag=blue_button] run particle dust 0 0.6 1 0.5 ~ ~0.2 ~

execute as @e[tag=idea_judge,tag=idea_judge_green] unless data entity @s RootVehicle run tag @s remove idea_judge_green
execute as @e[tag=idea_judge,tag=idea_judge_blue] unless data entity @s RootVehicle run tag @s remove idea_judge_blue
    
execute as @e[tag=idea_judge,tag=idea_judge_green] at @s run function 8_ideas2:game/update/green
execute as @e[tag=idea_judge,tag=idea_judge_blue] at @s run function 8_ideas2:game/update/blue

execute unless score Final Idea2Score1 matches 0.. run scoreboard players set Final Idea2Score1 0
execute unless score Final Idea2Score2 matches 0.. run scoreboard players set Final Idea2Score2 0
    
execute as @e[tag=idea_spawnpoint] at @s run spawnpoint @a[distance=..50] ~ ~ ~